#pragma once

#include <amp.h>
#include <iostream>

class TimeCheck
{
	concurrency::accelerator_view *_av;
	LARGE_INTEGER start, end;
public:
	TimeCheck(concurrency::accelerator_view *av = nullptr)
	{
		_av = av;
	}

	void Start()
	{
		if (_av != nullptr)
		{
			//	GPU ٸ.
			_av->wait();
		}
		QueryPerformanceCounter(&start);
	}

	double GetTime()
	{
		if (_av != nullptr)
		{
			_av->wait();
		}
		QueryPerformanceCounter(&end);
		LARGE_INTEGER freq;
		QueryPerformanceFrequency(&freq);
		return ((double(end.QuadPart) - double(start.QuadPart)) * 1000.0) / double(freq.QuadPart);
	}
};
